package br.unirio.processo.general.model.process;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class LinhaProcesso
{
	private List<Artefato> artefatos;
	private List<Processo> processos;
		
	public LinhaProcesso()
	{
		this.artefatos = new ArrayList<Artefato>();
		this.processos = new ArrayList<Processo>();
	}
	
	//artefatos
	public int getArtefatoCount()
	{
		return artefatos.size();
	}
	
	public Artefato getArtefatoIndex(int index)
	{
		return artefatos.get(index);
	}
	
	public Artefato getArtefatoPorNome(String nome)
	{
		for (Artefato artef : artefatos)
			if (artef.getNome().compareToIgnoreCase(nome) == 0)
				return artef;
		
		return null;
	}
	
	public void addArtefato(Artefato item)
	{
		artefatos.add(item);
	}
	
	public void removeArtefato(int index)
	{
		artefatos.remove(index);
	}
	
	public Iterator<Artefato> getArtefatos()
	{
		return artefatos.iterator();
	}
	
	//processos
	public int getProcessoCount()
	{
		return processos.size();
	}
	
	public Processo getProcessoIndex(int index)
	{
		return processos.get(index);
	}
	
	public Processo getProcessoPorNome(String nome)
	{
		for (Processo proc : processos)
			if (proc.getNome().compareToIgnoreCase(nome) == 0)
				return proc;
		
		return null;
	}
	
	public void addProcesso(Processo item)
	{
		processos.add(item);
	}
	
	public void removeProcesso(int index)
	{
		processos.remove(index);
	}
	
	public Iterator<Processo> getProcessos()
	{
		return processos.iterator();
	}
}