package br.unirio.processo.general.test;

import org.junit.Assert;
import org.junit.Test;

import unirio.experiments.instancegen.FlatPublisherReaderException;
import br.unirio.processo.general.model.component.ComponenteProcesso;
import br.unirio.processo.general.model.component.RepositorioComponentes;
import br.unirio.processo.general.model.process.Artefato;
import br.unirio.processo.general.model.process.LinhaProcesso;
import br.unirio.processo.general.model.process.Processo;
import br.unirio.processo.general.reader.ModeloProcessoReader;

public class TestModeloProcessoReader
{
	@Test
	public void testRepositorioComponentes() throws FlatPublisherReaderException
	{
		ModeloProcessoReader reader = new ModeloProcessoReader();
		reader.execute("data\\dadosotimizacao.txt");
		LinhaProcesso linha = reader.getLinhaProcesso();
		RepositorioComponentes componentes = reader.getRepositorioComponentes();
		
		//linha de processo
		Assert.assertEquals(1, linha.getProcessoCount());
		Processo proc = linha.getProcessoIndex(0);
		Assert.assertEquals("Gerncia de Projeto", proc.getNome());
		Assert.assertEquals(1, proc.getEntradaDisponivelCount());
		Assert.assertEquals("Viso", proc.getEntradaDisponivelIndex(0).getNome());
		Assert.assertEquals(4, proc.getProdutoEsperadoCount());
		Assert.assertEquals("Plano de Gerenciamento de Riscos com Indicadores", proc.getProdutoEsperadoIndex(0).getNome());
		
		//artefato
		Assert.assertEquals(40, linha.getArtefatoCount());
		Artefato inter = linha.getArtefatoIndex(7);
		Assert.assertEquals("Documentao Arquivada", inter.getNome());
		
		//componente
		Assert.assertEquals(41, componentes.getComponenteCount());
		ComponenteProcesso comp = componentes.getComponenteIndex(35);
		Assert.assertEquals("Elaborar Plano de Resoluo de Problemas com Equipes Designadas (dummy)", comp.getNome());
		Assert.assertEquals("Opcional", comp.getOpcionalidade());
		Assert.assertEquals("Invariante", comp.getVariabilidade());
		Assert.assertEquals(0, comp.getPotencialColaboracao(), 0.0001);
		Assert.assertEquals(1, comp.getArtefatoEntradaTodosCount());
		Assert.assertEquals("Viso", comp.getArtefatoEntradaMandatorioIndex(0).getNome());
		Assert.assertEquals(1, comp.getArtefatoSaidaCount());
		Assert.assertEquals("Plano de Resoluo de Problemas com Equipes Designadas", comp.getArtefatoSaidaIndex(0).getNome());
	}
}